<script setup lang="ts">
import { useRoute, useRouter } from 'vue-router'
import { onMounted, ref, watch } from 'vue'
import type { Group } from '@/api/gitlabHelperApi/groupsApi'
import GroupsApi from '@/api/gitlabHelperApi/groupsApi'
import type { Project } from '@/api/gitlabHelperApi/projectsApi'

import GitApiCall from '@/api/gitApi'
import GroupsCardsComponent from '@/components/gitlab/GroupsCardsComponent.vue'
import ProjectsCardsComponent from '@/components/gitlab/ProjectsCardsComponent.vue'
import ProjectsTableComponent from '@/components/gitlab/ProjectsTableComponent.vue'

const groupId = ref('')
const isVendor = ref(true)
const groups = ref<Array<Group>>([])
const projects = ref<Array<Project>>([])
const hasError = ref(false)
const hasWarning = ref(false)
const responseMessage = ref('')
const activeTab = ref(0)

const route = useRoute()
const router = useRouter()

const syncActiveTabWithRoute = () => {
  const queryTab = route.query.activeTab
  if (typeof queryTab === 'string')
    activeTab.value = Number.parseInt(queryTab, 10)
}

const updateQuery = (newTab: number) => {
  router.push({
    query: {
      ...route.query,
      activeTab: newTab.toString(),
    },
  })
}

watch(activeTab, newTab => {
  updateQuery(newTab)
})

const getGroupId = () => {
  console.info('INFO: getGroupId')

  const gitApi = new GitApiCall()

  groupId.value = route.params.id as string
  if (groupId.value === null || groupId.value === undefined || groupId.value === '') {
    console.debug('groupId.value: ', groupId.value)
    groupId.value = gitApi.vendorId
  }
  console.debug('groupId.value: ', groupId.value)
  isVendor.value = groupId.value === gitApi.vendorId
  console.debug('isVendor.value: ', isVendor.value)
}

const handleError = (error: any) => {
  hasError.value = true
  hasWarning.value = true
  if (error.response && error.response.status === 401) {
    responseMessage.value = 'Authentication error. You are not authorized to view this resource. '
      + 'Please verify your GitLab integration or contact your system administrator for further assistance.'
  }
  else {
    responseMessage.value = error.message || 'An unexpected error occurred while processing your request.'
  }
}

const getSubGroup = async () => {
  console.info('INFO: getSubGroup for group: ', groupId.value)

  const gitApi = new GitApiCall()
  try {
    const response = await gitApi.getSubGroup(groupId.value)

    groups.value = response.data
    console.debug('getSubGroup groups.value: ', groups.value)
  }
  catch (error) {
    handleError(error)
  }
}

const getProjects = async () => {
  console.info('INFO: getProjects for group: ', groupId.value)

  const groupApi = new GroupsApi()
  try {
    const response = await groupApi.getProjects(groupId.value)

    projects.value = response.data.data
    console.debug('getProjects projects.value: ', projects.value)
  }
  catch (error) {
    handleError(error)
  }
}

const getAllData = async () => {
  await getGroupId()
  await getSubGroup()
  await getProjects()
}

watch(() => route.params.id, async (newId, oldId) => {
  console.info('INFO: watch router.params.id: ', newId, oldId)
  await getAllData()
})

onMounted(() => {
  syncActiveTabWithRoute()
  getAllData()
})
</script>

<template>
  <div>
    <VAlert
      v-model="hasError"
      closable
      close-label="Close"
      border="start"
      type="error"
      variant="tonal"
      class="mb-1"
    >
      {{ responseMessage }}.
    </VAlert>

    <VAlert
      v-model="hasWarning"
      closable
      close-label="Close"
      border="start"
      type="warning"
      variant="tonal"
      class="mb-1"
    >
      You may not have any project or group assigned from GitLab yet.
      Please verify your GitLab account or contact your system administrator for further assistance.
    </VAlert>

    <div class="d-flex justify-end mb-4">
      <VBtn
        :variant="activeTab === 0 ? 'contained' : 'text'"
        @click="activeTab = 0"
      >
        <VIcon
          icon="tabler-layout-grid"
          size="22"
        />
      </VBtn>
      <VBtn
        :variant="activeTab === 1 ? 'contained' : 'text'"
        @click="activeTab = 1"
      >
        <VIcon
          icon="tabler-list"
          size="22"
        />
      </VBtn>
    </div>

    <div v-if="activeTab === 0">
      <!-- groups-breadcrumb-component/ -->
      <GroupsCardsComponent
        v-if="groups.length !== 0"
        :groups="groups"
        class="mb-4"
      />
      <ProjectsCardsComponent
        v-if="projects.length !== 0"
        :projects="projects"
        class="mb-4"
      />
    </div>
    <div v-if="activeTab === 1">
      <!-- groups-breadcrumb-component/ -->
      <!-- projects-table-component :projects="projects" :group-id="groupId"/ -->
      <GroupsCardsComponent
        v-if="groups.length !== 0"
        :groups="groups"
        class="mb-4"
      />
      <ProjectsTableComponent
        :group-id="groupId"
        :projects="projects"
        class="mt-4"
      />
    </div>
  </div>
</template>

<style scoped>
.d-flex.justify-end.mb-4 button {
  padding: 2px;
}
</style>
